/* which.cmd: which command with 'search duplicates' */
/* (c)2003, Salvador Parra Camacho */

parse arg command

parse arg command

if command = '' then
	do
	say ''
	say '  Syntax: which2 [command_to_search]'
	exit
	end

type.0 = 4
type.1 = 'com'
type.2 = 'exe'
type.3 = 'cmd'
type.4 = 'bat'

type = search()

say ''
say '  '||filespec

path_dirs = value('PATH',,'OS2ENVIRONMENT')
path_dirs = translate(path_dirs,' ',';')
tfilespec = translate(filespec)

do i = 1 to words(path_dirs)
	path_dir.i = strip(word(path_dirs,i),,'\')
	do j = 1 to type.0
		command.i = path_dir.i||'\'||command||'.'||type.j
		duplicate = stream(command.i,'c','query exists')
		tduplicate = translate(duplicate)
		select
			when tduplicate = '' then
				nop
			when tduplicate = tfilespec then
				say '    * '||duplicate
			otherwise
				say '      '||duplicate
		end
	end
end

exit

search:

com_command = command||'.com'
filespec = SysSearchPath('PATH',com_command)
if filespec <> '' then return 'com'

exe_command = command||'.exe'
filespec = SysSearchPath('PATH',exe_command)
if filespec <> '' then return 'exe'

cmd_command = command||'.cmd'
filespec = SysSearchPath('PATH',cmd_command)
if filespec <> '' then return 'cmd'

bat_command = command||'.bat'
filespec = SysSearchPath('PATH',bat_command)
if filespec <> '' then return 'bat'

filespec = '  Command not found.'

return 0